package at.jku.ssw.pi.set.tree.ue03;

import at.jku.ssw.pi.IntIterator;
import at.jku.ssw.pi.set.Set;
import at.jku.ssw.pi.util.Out;

class BinaryTreeSetTest {

	public static void main(String[] args) {
		test1();
		test2();
		test3();
		test4();
		test5();
		test6();
		test7();
	}

	static void test1() {
		Out.println("\n*** Test 1 - add ***");
		Set set = createSet(new int[] { 9, 12, 17, 25, 5, 2, 8, 17, 25, 5, 1, 0 });
		printSet(set);
		makeDot((BinaryTreeSet) set, "test1.dot");
	}

	static void test2() {
		Out.println("\n*** Test 2 - contains ***");
		Set set = createSet(new int[] { 9, 11, 0, 13, 15, 2, 24 });
		printSet(set);
		Out.println("contains(0)=" + set.contains(0));
		Out.println("contains(23)=" + set.contains(23));
		Out.println("contains(15)=" + set.contains(15));
		makeDot((BinaryTreeSet) set, "test2.dot");
	}

	static void test3() {
		Out.println("\n*** Test 3 - remove leaf ***");
		BinaryTreeSet set = createSet(new int[] { 11, 3, 1, 5, 13, 12, 25, 6 });
		printSet(set);
		Out.println("contains(6)=" + set.contains(6));
		makeDot(set, "test3a.dot");
		Out.println("remove(6)=" + set.remove(6));
		printSet(set);
		Out.println("contains(6)=" + set.contains(6));
		Out.println("remove(6)=" + set.remove(6));
		makeDot(set, "test3b.dot");
	}

	static void test4() {
		Out.println("\n*** Test 4 - remove inner node ***");
		BinaryTreeSet set = createSet(new int[] { 11, 3, 1, 5, 13, 12, 25, 6 });
		printSet(set);
		Out.println("contains(3)=" + set.contains(3));
		makeDot(set, "test4a.dot");
		Out.println("remove(3)=" + set.remove(3));
		printSet(set);
		Out.println("contains(3)=" + set.contains(3));
		makeDot(set, "test4b.dot");
	}

	static void test5() {
		Out.println("\n*** Test 5 - remove root ***");
		BinaryTreeSet set = createSet(new int[] { 11, 3, 1, 5, 13, 12, 25, 6 });
		printSet(set);
		Out.println("contains(11)=" + set.contains(11));
		makeDot(set, "test5a.dot");
		Out.println("remove(11)=" + set.remove(11));
		printSet(set);
		Out.println("contains(11)=" + set.contains(11));
		makeDot(set, "test5b.dot");
	}

	static void test6() {
		Out.println("\n*** Test 6 - union, intersect, diff, subtract ***");
		Set set1 = createSet(new int[] { 0, 1, 2 });
		Out.print("set1= ");
		printSet(set1);
		Set set2 = createSet(new int[] { 2, 3, 4 });
		Out.print("set2= ");
		printSet(set2);
		Out.print("set1.union(set2)= ");
		printSet(set1.union(set2));
		Out.print("set1.intersect(set2)= ");
		printSet(set1.intersect(set2));
		Out.print("set1.diff(set2)= ");
		printSet(set1.diff(set2));
		Out.print("set2.diff(set1)= ");
		printSet(set2.diff(set1));
		Out.print("set1.subtract(set2)= ");
		printSet(set1.subtract(set2));
		Out.print("set2.subtract(set1)= ");
		printSet(set2.subtract(set1));
	}

	static void test7() {
		Out.println("\n*** Test 7 - insert sorted values ***");
		BinaryTreeSet set = new BinaryTreeSet();
		for (char ch = 0; ch <= 25; ch++) {
			set.add(ch);
		}
		printSet(set);
		makeDot(set, "test7.dot");
	}

	static BinaryTreeSet createSet(int[] values) {
		BinaryTreeSet set = new BinaryTreeSet();
		for (int i = 0; i < values.length; i++) {
			set.add(values[i]);
		}
		return set;
	}

	private static void printSet(Set set) {
		printSetWithIterator(set, set.iterator());
	}

	private static void printSetWithIterator(Set set, IntIterator it) {
		Out.print("size=" + set.size() + ": ");
		boolean first = true;
		while (it.hasNext()) {
			if (!first) {
				Out.print(", ");
			} else {
				first = false;
			}
			Out.print(it.next());
		}
		Out.println();
	}

	static void makeDot(BinaryTreeSet set, String filename) {
		Out.open(filename);
		Out.print(set.makeDot());
		Out.close();
	}

}